<?php

namespace Drupal\drupal_helper\TwigExtension;
use Drupal\Core\Datetime\DrupalDateTime;
use Drupal\views\Views;


/**
 * Class DrupalHelperTwigExtension.
 */
class DrupalHelperTwigExtension extends \Twig_Extension {

    /**
     * {@inheritdoc}
     */
    public function getTokenParsers() {
        return [];
    }

    /**
     * {@inheritdoc}
     */
    public function getNodeVisitors() {
        return [];
    }

    /**
     * {@inheritdoc}
     */
    public function getFilters() {
        return [];
    }

    /**
     * {@inheritdoc}
     */
    public function getTests() {
        return [];
    }

    /**
     * {@inheritdoc}
     */
    public function getFunctions() {
        return [
            'current_user' => new \Twig_Function_Function(['Drupal\drupal_helper\TwigExtension\DrupalHelperTwigExtension', 'twig_current_user']),
            'current_lang' => new \Twig_Function_Function(['Drupal\drupal_helper\TwigExtension\DrupalHelperTwigExtension', 'twig_current_lang']),
            'is_login' => new \Twig_Function_Function(['Drupal\drupal_helper\TwigExtension\DrupalHelperTwigExtension', 'isLoginTwig']),
            'current_url' => new \Twig_Function_Function(['Drupal\drupal_helper\TwigExtension\DrupalHelperTwigExtension', 'twig_current_url']),
            'get_parameter' => new \Twig_Function_Function(['Drupal\drupal_helper\TwigExtension\DrupalHelperTwigExtension', 'twig_get_parameter']),
            'node_url' => new \Twig_Function_Function(['Drupal\drupal_helper\TwigExtension\DrupalHelperTwigExtension', 'node_url']),
            'block_load_by_type' => new \Twig_Function_Function(['Drupal\drupal_helper\TwigExtension\DrupalHelperTwigExtension', 'block_load_by_type']),
            'get_module_path' => new \Twig_Function_Function(['Drupal\drupal_helper\TwigExtension\DrupalHelperTwigExtension', 'get_module_path']),
            'base_url' => new \Twig_Function_Function(['Drupal\drupal_helper\TwigExtension\DrupalHelperTwigExtension', 'base_url']),
            'taxonomy_url' => new \Twig_Function_Function(['Drupal\drupal_helper\TwigExtension\DrupalHelperTwigExtension', 'taxonomy_url']),
            'die' => new \Twig_Function_Function(['Drupal\drupal_helper\TwigExtension\DrupalHelperTwigExtension', 'die_twig']),
            'array_values' => new \Twig_Function_Function(['Drupal\drupal_helper\TwigExtension\DrupalHelperTwigExtension', 'array_value_twig']),
            'hasRole' => new \Twig_Function_Function(['Drupal\drupal_helper\TwigExtension\DrupalHelperTwigExtension', 'has_role_twig']),
            'paragraph_form' => new \Twig_Function_Function(['Drupal\drupal_helper\TwigExtension\DrupalHelperTwigExtension', 'render_form_paragraph_twig']),
            'id_by_url' => new \Twig_Function_Function(['Drupal\drupal_helper\TwigExtension\DrupalHelperTwigExtension', 'twig_id_by_url']),
            'taxonomy_children' => new \Twig_Function_Function(['Drupal\drupal_helper\TwigExtension\DrupalHelperTwigExtension', 'twgi_taxonomy_children']),
            'in_array' => new \Twig_Function_Function(['Drupal\drupal_helper\TwigExtension\DrupalHelperTwigExtension', 'twig_in_array']),
            'current_url_alias' => new \Twig_Function_Function(['Drupal\drupal_helper\TwigExtension\DrupalHelperTwigExtension', 'twig_current_url_alias']),
            'config' => new \Twig_Function_Function(['Drupal\drupal_helper\TwigExtension\DrupalHelperTwigExtension', 'twig_config']),
            'var_dump' => new \Twig_Function_Function(['Drupal\drupal_helper\TwigExtension\DrupalHelperTwigExtension', 'twig_var_dump']),
            'path_theme' => new \Twig_Function_Function(['Drupal\drupal_helper\TwigExtension\DrupalHelperTwigExtension', 'twig_get_current_path_theme']),
            'modulo' => new \Twig_Function_Function(['Drupal\drupal_helper\TwigExtension\DrupalHelperTwigExtension', 'modulo_twig']),
            'render_view' => new \Twig_Function_Function(['Drupal\drupal_helper\TwigExtension\DrupalHelperTwigExtension', 'twig_render_view']),
            'theme_logo' => new \Twig_Function_Function(['Drupal\drupal_helper\TwigExtension\DrupalHelperTwigExtension', 'twig_theme_logo']),
            'price' => new \Twig_Function_Function(['Drupal\drupal_helper\TwigExtension\DrupalHelperTwigExtension', 'twig_price_format']),
            'count_comments' => new \Twig_Function_Function(['Drupal\drupal_helper\TwigExtension\DrupalHelperTwigExtension', 'count_comments']),
            'views_result' => new \Twig_Function_Function(['Drupal\drupal_helper\TwigExtension\DrupalHelperTwigExtension', 'views_result']),
            'strtotime' => new \Twig_Function_Function(['Drupal\drupal_helper\TwigExtension\DrupalHelperTwigExtension', 'twig_strtotime']),
            'array_push' => new \Twig_Function_Function(['Drupal\drupal_helper\TwigExtension\DrupalHelperTwigExtension', 'twig_array_push'])

        ];
    }
    public static function twig_array_push($array,$item,$key = null){
        if($key){
          $array[$key] = $item ;
        }else{
            $array[] = $item ;
        }
        return $array;
    }
    public static function twig_strtotime($date){
        $date = new DrupalDateTime($date);
        return $date->getTimestamp();
    }
    public static function views_result($view_name,$diplay_id){
        $view = Views::getView($view_name);
        $view->setDisplay($diplay_id);
        $view->execute();
        return $view->result ;
    }
    public static function count_comments($nid){
        $twig_base = new \Drupal\drupal_helper\DrupalHepler();
        return $twig_base->helper->count_comments($nid);
    }
    public static function twig_price_format($price,$decimal_number=0 ,$decimal_point=',' , $thousands_sep=' ') {
        return number_format($price,$decimal_number, $decimal_point, $thousands_sep);
    }
    public static function twig_theme_logo(){
        $twig_base = new \Drupal\drupal_helper\DrupalHepler();
        return $twig_base->helper->theme_logo();
    }
    public static function twig_render_view($view_mode ,$item, $entity_type='node'){
        $view_builder = \Drupal::entityTypeManager()->getViewBuilder($entity_type);
        $result =  $view_builder->view($item, $view_mode);
        return \Drupal::service('renderer')->renderRoot($result);
    }
    public static function modulo_twig($a , $b){
        return  ($a % $b);
    }
    public static function twig_config($config_base,$config_name){
        $config = \Drupal::config($config_base);
        return  $config->get($config_name);

    }

    public static function twig_get_current_path_theme(){
        $twig_base = new \Drupal\drupal_helper\DrupalHepler();
        global  $base_url ;
        return $base_url.'/'.$twig_base->helper->get_current_path_theme();
    }
    public static function twig_current_url_alias(){
        $twig_base = new \Drupal\drupal_helper\DrupalHepler();
        return $twig_base->helper->current_url_alias();
    }
    public static function twig_var_dump($content){
        return var_dump($content);
    }
    public static function twig_in_array($item , $array){
        return in_array($item,$array);
    }
    public static function twgi_taxonomy_children($vid , $tid){
        $twig_base = new \Drupal\drupal_helper\DrupalHepler();
        return $twig_base->helper->taxonomy_children($vid , $tid);
    }
    public static function twig_id_by_url($url = null){
        $twig_base = new \Drupal\drupal_helper\DrupalHepler();
        return $twig_base->helper->get_numeric_args_url($url);
    }
    public static function render_form_paragraph_twig($bundle,$id=null){
        $twig_base = new \Drupal\drupal_helper\DrupalHepler();
        return $twig_base->form->render_form_paragraph($bundle,$id);
    }


    public static function has_role_twig($role_name,$uid){
        $twig_base = new  \Drupal\drupal_helper\DrupalHepler();
        return $twig_base->user->hasRole($role_name,$uid);
    }
    public static function array_value_twig($array){
        if($array==null){
            $array =[];
        }
        return  array_values($array);
    }
    public static function twig_current_lang(){
        return  $language = \Drupal::languageManager()->getCurrentLanguage()->getId();
    }
    public static function twig_current_user(){
        $twig_base = new  \Drupal\drupal_helper\DrupalHepler();
        return  $twig_base->helper->current_user();
    }
    public  static function die_twig(){
        return die();
    }
    public static function isLoginTwig() {
        $twig_base = new  \Drupal\drupal_helper\DrupalHepler();
        return  $twig_base->helper->is_login();
    }
    public static function twig_current_url(){
        $twig_base = new  \Drupal\drupal_helper\DrupalHepler();
        return  $twig_base->helper->current_url();
    }
    public static function twig_get_parameter(){
        return   \Drupal::request()->query->all();
    }


    public static function node_url($nid){
        $twig_base = new  \Drupal\drupal_helper\DrupalHepler();
        return $twig_base->helper->node_url($nid);
    }
    public static function block_load_by_type($type){
        $twig_base = new  \Drupal\drupal_helper\DrupalHepler();
        return $twig_base->helper->block_custom_load_by_type($type);

    }

    public static function  get_module_path($module_name){
        $twig_base = new  \Drupal\drupal_helper\DrupalHepler();
        return $twig_base->helper->get_module_path($module_name);
    }

    public  static function base_url(){
        global $base_url ;
        return $base_url;
    }

    public  static function taxonomy_url($tid){
        $twig_base = new  \Drupal\drupal_helper\DrupalHepler();
        $alias = $twig_base->helper->taxonomy_url_alias($tid);

        return $alias  ;
    }

    /**
     * {@inheritdoc}
     */
    public function getOperators() {
        return [];
    }

    /**
     * {@inheritdoc}
     */
    public function getName() {
        return 'drupal_helper.twig.extension';
    }

}
